# copyright: Huynh Duong Phuong Vi
# www.sketchupforyou.com
module S4U
    def self.get_file(dir_s4u_name,s4u_name,ext=".txt")
        file_name = s4u_name + ext
        file_name_full = File.join dir_s4u_name,file_name
        if File.exist?(file_name_full)
            file= File.new(file_name_full,"r")
            str=file.readlines
            file.close
            return str.collect{|s| s.chomp}
        end
        return false
        rescue=>error
            p error,error.backtrace.join('\n')
            return false
    end
    def self.set_file(dir_s4u_name,s4u_name,list,ext=".txt")
        file_name = s4u_name + ext
        file_name_full = File.join dir_s4u_name,file_name
        file= File.new(file_name_full, mode: 'w:UTF-8')
        str=list.join("\n")
        file.syswrite str
        file.close
        return true
        rescue=>error
            p error,error.backtrace.join('\n')
            return false
    end
	module S4u_stair
		def self.find_vertices(edges_new1,check_angle=false)
			edges_new=edges_new1.clone
			i=0;list=[]
			while (edges_new.length>0) && (i<edges_new1.length)
				ls=[]
				lcs=[]
				vers=edges_new.flat_map{|e| e.vertices}.uniq
				if f=vers.find{|v| (l=(v.edges & edges_new1).length )&& l && ((l==1) || (l>2))}
					ls<<f
					vers.delete f
				elsif f=vers.find{|v| (v.edges & edges_new).length==1}
					ls<<f
					vers.delete f
				else
					ls<< vers.shift
				end
				length=vers.length
				j=0
				while (edges_new.length>0) && (j< length) && (vers.length>0)
					j+=1
					vs=ls.last.edges.flat_map{|e| e.vertices} & vers
					lc=vs.find{|l|
							l.common_edge(ls.last) &&
							(((l.edges & ls.last.edges) & edges_new).length==1)
						}
					if lc
						led=(lc.edges & ls.last.edges) & edges_new
						edges_new-=led
						ls<< lc
						lcs<< led[0]
						vers.delete(lc)
						break if ((lc.edges & edges_new1).length>2)
						if check_angle
							#break if ((ed=(lc.edges & edges_new1)) && ed.length>1 && angle_between_edges(ed[0],ed[1]))
							break if ((ed=(lc.edges & edges_new1)) && ed.length>1 && angle_between_edges(ed[0],ed[1],check_angle))
						end
					end
				end
				list<< [ls,lcs]
				i+=1
			end
			return list
		end
		def self.angle_between_edges(e1,e2,ang=nil)
			if ang.class==Float
				@angle_break=ang
			else #if !@angle_break || !ang
				@angle_break=20.degrees
			end
			origin=(e1.vertices & e2.vertices)[0]
			v1=origin.position-e1.other_vertex(origin).position
			v2=e2.other_vertex(origin).position-origin.position
			a=v1.angle_between v2
			return (a>=@angle_break)
		end
		def self.check_direction_edge(face,points1)
			points=points1.collect{|p| p.project_to_plane(face.plane)}
			if (points.length>1) && (points[1]!=points[0]) && face
				v=points[1]-points[0]
				vy=v.cross face.normal
				vy.length=points[0].distance(points[1])*0.01
				pm=Geom::Point3d.new (points[0].x+points[1].x)*0.5,(points[0].y+points[1].y)*0.5,(points[0].z+points[1].z)*0.5
				p = pm + vy
				if face.classify_point(p)==1
					return vy
				else
					return vy.reverse
				end
			end
		end
		def self.extrude_points(g,points,vec,length=nil,face=nil,direct=1)
			entities=g.entities
			trans=g.transformation
			fs=[]
			vec.length=length if !length
			point=points[0] if !point
			ed= points
			ed1=points.collect{|p| p+vec}
			(0..ed.length-2).each{|i|
				if (ed[i]!=ed[i+1]) && (ed1[i+1]!=ed1[i])
					f=entities.add_face ed[i],ed[i+1],ed1[i+1],ed1[i]
					if f
						if face
							v3= check_direction_edge(face,[ed[i].transform(trans),ed[i+1].transform(trans)])
							v3.reverse! if direct==-1
							v_normal=f.normal.transform(trans)
							if	v3 && (v_normal.samedirection?(v3) || (v_normal.angle_between(v3) <= Math::PI*0.5))
								f.reverse!
							end
						end
						fs<<f
					end
				end
			}
			self.clean_edge(entities)
			return fs
		end
		def self.get_info_points(points)
			length=0
			ps=[[points[0],0]]
			(1..points.length-1).each{|i|
				length=points[i].distance(points[i-1])
				ps<<[points[i],(ps[i-1][1]+length)]
			}
			return ps
		end
		def self.get_points_equal(points,st)
			return points if points[-1][1]<=st
			ps_new=[]
			0.step(points[-1][1],st).each{|s|
				if s==0
					ps_new<<[points[0][0],0]
				else
					(1..points.length-1).each{|j|
						if (s<= points[j][1] )&& (s> points[j-1][1])
							vec=points[j][0]-points[j-1][0]
							if vec.length!=0
								vec.length= s-points[j-1][1]
								p=points[j-1][0]+vec
								ps_new<<[p,s]
							end
						end
					}
				end
			}
			ps_new<< points[-1] if ps_new[-1][0]!=(points[-1][0])
			return ps_new
		end
		def self.balance_points(points,points1)
			ps=[];i=0
			(0..points1.length-1).each{|j|

				if ((points[i][1].to_f/points[-1][1]) < (points1[j][1].to_f/points1[-1][1])) && (i<points.length-1)
				ps<<points[i] if i<points.length
					i+=1
				end
			}
			ps=points if ps.length<points.length
			return ps
		end

		def self.extrude_points_points(g,points,points1,face=nil,direct=1,normal=nil)
				entities=g.entities
				trans=g.transformation
				ed =points
				ed1=points1
				fs=[]
				ps=[];ps1=[];
				if ed.length != ed1.length
					ps= self.get_info_points(ed)
					ps1= self.get_info_points(ed1)
					if ps1.length < ps.length
						ps1=balance_points(ps1,ps)
						ed1=ps1.collect{|p| p[0]}
					else
						ps=balance_points(ps,ps1)
						ed=ps.collect{|p| p[0]}
					end
				end
				if ed.length>ed1.length
					l=(ed.length-ed1.length)
					l2=l.to_i/2
					l1=l-l2
					ed1= Array.new(l1,points1[0]) + ed1 + Array.new(l2,points1[-1])
				elsif ed.length<ed1.length
					l=(ed1.length-ed.length)
					l2=l.to_i/2
					l1=l-l2
					ed = Array.new(l1,points[0]) + ed + Array.new(l2,points[-1])
				end
				(0..ed.length-2).each{|i|
					if (ed[i+1]!=ed[i]) && (ed[i]!=ed1[i]) && (ed[i+1]!=ed1[i])
						f=entities.add_face ed[i],ed[i+1],ed1[i]
						if f
							if face
								v_normal=f.normal.transform(trans)
								v3= check_direction_edge(face,[ed[i].transform(trans),ed[i+1].transform(trans)])
								v3.reverse! if direct==-1
								if v3 && ( (v_normal.angle_between(v3) <= Math::PI*0.5))
									f.reverse!
								end
							elsif normal
								v_normal=f.normal.transform(trans)
								if (v_normal.samedirection?(normal.reverse) || (v_normal.angle_between(normal.reverse) <= Math::PI*0.5))
									f.reverse!
								end
							end
							fs<<f
						end
					end
					if ed1[i+1]!=ed1[i] && ed1[i+1]!=ed[i+1] && ed1[i]!=ed[i+1]
						f=entities.add_face ed[i+1],ed1[i+1],ed1[i]
						if f
							if face
								v_normal=f.normal.transform(trans)
								v3= check_direction_edge(face,[ed1[i].transform(trans),ed1[i+1].transform(trans)])
								v3.reverse! if direct==-1
								if v3 && ( (v_normal.angle_between(v3) <= Math::PI*0.5))
									f.reverse!
								end
							elsif normal
								v_normal=f.normal.transform(trans)
								if (v_normal.samedirection?(normal.reverse) || (v_normal.angle_between(normal.reverse) <= Math::PI*0.5))
									 f.reverse!
								end
							end
							fs<<f
						end
					end
				}
				self.clean_edge(entities)
				return fs
		end
		def self.extrude_points_points1(g,points,points1,face=nil,direct=1,normal=nil)
				entities=g.entities
				trans=g.transformation
				ed =points
				ed1=points1
				fs=[]
				if ed.length>ed1.length
					l=(ed.length-ed1.length)
					l2=l.to_i/2
					l1=l-l2
					ed1= Array.new(l1,points1[0]) + ed1 + Array.new(l2,points1[-1])
				elsif ed.length<ed1.length
					l=(ed1.length-ed.length)
					l2=l.to_i/2
					l1=l-l2
					ed = Array.new(l1,points[0]) + ed + Array.new(l2,points[-1])
				end
				(0..ed.length-2).each{|i|
					if (ed[i+1]!=ed[i]) && (ed[i]!=ed1[i]) && (ed[i+1]!=ed1[i])
						f=entities.add_face ed[i],ed[i+1],ed1[i]
						if f
							if face
								v_normal=f.normal.transform(trans)
								v3= check_direction_edge(face,[ed[i].transform(trans),ed[i+1].transform(trans)])
								v3.reverse! if direct==-1
								if v3 && ( (v_normal.angle_between(v3) <= Math::PI*0.5))
									f.reverse!
								end
							elsif normal
								v_normal=f.normal.transform(trans)
								if (v_normal.samedirection?(normal.reverse) || (v_normal.angle_between(normal.reverse) <= Math::PI*0.5))
									f.reverse!
								end
							end
							fs<<f
						end
					end
					if ed1[i+1]!=ed1[i] && ed1[i+1]!=ed[i+1] && ed1[i]!=ed[i+1]
						f=entities.add_face ed[i+1],ed1[i+1],ed1[i]
						if f
							if face
								v_normal=f.normal.transform(trans)
								v3= check_direction_edge(face,[ed1[i].transform(trans),ed1[i+1].transform(trans)])
								v3.reverse! if direct==-1
								if v3 && ( (v_normal.angle_between(v3) <= Math::PI*0.5))
									f.reverse!
								end
							elsif normal
								v_normal=f.normal.transform(trans)
								if (v_normal.samedirection?(normal.reverse) || (v_normal.angle_between(normal.reverse) <= Math::PI*0.5))
									 f.reverse!
								end
							end
							fs<<f
						end
					end
				}
				self.clean_edge(entities)
				return fs
		end
		def self.slope_points(points,vec,height=0)
				return points if points.length<2 || vec.length==0
				total_length=0
				(0..points.length-2).each{|i| total_length+=points[i].distance points[i+1]}
				length=0
				ps=[]
				len=0
				(0..points.length-1).each{|i|
					v=vec.clone
					if i==0
						v.length=height
					else
						length+=points[i-1].distance points[i]
						len=vec.length*length/total_length
						(v.length=len+height) if v.length!=0
					end
					ps << (points[i] + v)
				}
				return ps
		end
		def self.offset_points(points,vec,vecz,border1,border2)
			#points1=points.collect{|p| p + vec}
			points1=[]
			if points.length>1
				v=points[1]-points[0]
				v=vecz.cross v
				v.length=vec.length
				points1<< (points[0]+v)
				if points.length>2
					(1..points.length-2).each{|i|
						v=points[i]-points[i-1]
						v1=vecz.cross v
						v1.length=vec.length
						line1=[(points[i-1]+v1),(points[i]+v1)]
						v=points[i+1]-points[i]
						v1=vecz.cross v
						v1.length=vec.length
						line2=[(points[i]+v1),(points[i+1]+v1)]
						p=Geom::intersect_line_line(line1,line2)
						points1<<p if p
					}
				end
				v=points[-1]-points[-2]
				v=vecz.cross v
				v.length=vec.length
				points1<<(points[-1]+v)
			end
			p1=[]
			p2=[]
			if border1 && !border1.empty?
				p=S4U::S4u_stair.intersect_points_points(border1,points1[0..1])
				if p
					points1[0]=p[0]
					p1=border1[0..p[1]]
					p1<<p[0]
				end
			end
			if border2 && !border2.empty?
				p=S4U::S4u_stair.intersect_points_points(border2,points1[-2..-1])
				if p
					points1[-1]=p[0]
					p2=border2[0..(p[1])]
					p2<<p[0]
				end
			end
			return [points1,p1,p2]
		end
		def self.offset_points_border(points,vec,vecz,border1=nil,border2=nil)
			points1=[]
			if vec.length!=0
				if points.length==1
					points[0]=points[0]+vec.clone
				elsif points.length==2
					v=points[1]-points[0]
					v=vecz.cross v
					v.length=vec.length
					points1<< (points[0]+v.clone)
					# p points1[-1]
					v1=points[1]-points[0]
					v1=vecz.cross v1
					v1.length=vec.length
					# p points[1]
					points1<<(points[1]+v1.clone)
					# p points1[-1],"asdf"
				elsif points.length>2
					v=points[1]-points[0]
					v=vecz.cross v
					v.length=vec.length
					points1<< (points[0]+v.clone)
					(1..points.length-2).each{|i|
						v1=points[i]-points[i-1]
						v1=vecz.cross v1
						v1.length=vec.length
						line1=[(points[i-1]+v1),((points[i]+v1)-(points[i-1]+v1))]
						v2=points[i+1]-points[i]
						v2=vecz.cross v2
						v2.length=vec.length
						line2=[(points[i]+v2),((points[i+1]+v2)-(points[i]+v2))]
						p=Geom::intersect_line_line(line1,line2)
						points1<<p if p
					}
					v3=points[-1]-points[-2]
					v3=vecz.cross v3
					v3.length=vec.length
					points1<<(points[-1]+v3.clone)
				else
					points1=points
				end
			else
				points1=points
			end
			if border1 && border1[0] && border1[1] && points1.length>1
				pl=[border1[0],(border1[0].vector_to border1[1])]
				p=Geom::intersect_line_plane([points1[0],points1[0].vector_to(points1[1])],pl)
				points1[0]=p if p
			end
			if border2 && border2[0] && border2[1] && points1.length>1
				pl=[border2[0],(border2[0].vector_to border2[1])]
				p=Geom::intersect_line_plane([points1[-2],(points1[-2].vector_to(points1[-1]))],pl)
				points1[-1]=p if p
			end
			return points1
		end
		def self.offset_points_plane(points,vec,vecz,border1=nil,border2=nil)
			points1=[]
			if vec && vec.length!=0 && points.length>1
					v=points[1]-points[0]
					v=vecz.cross v
					v.length=vec.length
					points1<< (points[0]+v)
					if points.length>2
						(1..points.length-2).each{|i|
							v=points[i]-points[i-1]
							v1=vecz.cross v
							v1.length=vec.length
							line1=[(points[i-1]+v1),((points[i]+v1)-(points[i-1]+v1))]
							v=points[i+1]-points[i]
							v1=vecz.cross v
							v1.length=vec.length
							line2=[(points[i]+v1),((points[i+1]+v1)-(points[i]+v1))]
							p=Geom::intersect_line_line(line1,line2)
							points1<<p if p
						}

					end
					v=points[-1]-points[-2]
					v=vecz.cross v
					v.length=vec.length
					points1<<(points[-1]+v)
			else
				points1=points
			end
			if border1 && border1[0] && border1[1] && points1.length>1
				p=Geom::intersect_line_plane([points1[0],points1[0].vector_to(points1[1])],border1)
				if p
					points1[0]=p

				end
			end
			if border2 && border2[0] && border2[1] && points1.length>1
				p=Geom::intersect_line_plane([points1[-2],(points1[-2].vector_to(points1[-1]))],border2)
				if p
					points1[-1]=p
				end
			end
			return points1
		end
		def self.move_points(points,vec,border1=nil,border2=nil)
			points1=points.collect{|p| p + vec}
			p1=[]
			p2=[]
			if border1 && !border1.empty?
				p=S4U::S4u_stair.intersect_points_points(border1,points1[0..1])
				if p
					points1[0]=p[0]
					p1=border1[0..p[1]]
					p1<<p[0]
				end
			end
			if border2 && !border2.empty?
				p=S4U::S4u_stair.intersect_points_points(border2,points1[-2..-1])
				if p
					points1[-1]=p[0]
					p2=border2[0..(p[1])]
					p2<<p[0]
				end
			end
			return [points1,p1,p2]
		end
		def self.clean_edge(entities,delete=false,ang=0.15)
			edge_selected=[]
			edge_selected1=[]
			entities.grep(Sketchup::Edge).each{|e|
				if e.faces.length==0 ||
				(e.faces.length==2 &&
				#e.faces[0].material==e.faces[1].material && e.faces[0].back_material==e.faces[1].back_material &&
				#e.faces[0].normal.samedirection?( e.faces[1].normal))
				(e.faces[0].normal.angle_between(e.faces[1].normal) <= 0.0001))
					edge_selected<<e
				elsif e && e.valid? && (e.faces.length==2) &&
				(e.faces[0].normal.angle_between( e.faces[1].normal) <= Math::PI*ang )
					edge_selected1<<e
				end
			}
			if delete
				edge_selected.each{|e| e.erase! if e.valid? }
			else
				edge_selected1+=edge_selected
			end
			(edge_selected1).compact.each{|e|
				(e.smooth=e.soft=true) if  e && e.valid?
			}
		end
		def self.intersect_points_points(points,points1)
			(0..points.length-2).each{|i|
				line=[points[i+1],points[i]]
				(0..points1.length-2).each{|j|
					p = Geom::intersect_line_line(line,points1[j..j+1])
					if p && ((p.distance(line[0])+p.distance(line[-1]))== line[0].distance(line[-1]))
						return [p,i]
					end
				}
			}
			return nil
		end
		class Stair
			attr_accessor :origin,:xaxis,:yaxis,:zaxis,:border
			def initialize(mode=0)
				@origin=ORIGIN
				@xaxis=X_AXIS;@yaxis=Y_AXIS,@zaxis=Z_AXIS
				@scale_factor= Sketchup.version.to_i > 17 ? UI.scale_factor : 1
				@scale_factor = 1.5 if @scale_factor>1.8
				@snap=20*@scale_factor
				@mode=mode
				name= IS_OSX ? "icon_mouse.pdf" : "icon_mouse.svg"
				cursor_path = File.join(File.dirname(__FILE__),name)
				@cursor_id = UI.create_cursor(cursor_path, 0, 0)

				@border=[]
                @list_type=[Strings["Make Stair-Simple"],
							Strings["Make Stair-Slab"],
							Strings["Make Stair-ZigZag"],
							Strings["Make Stair-Steps"],
							Strings["Make Stair-Extrude"],
							Strings["Make Stair-Treads"],
							Strings["Make Slope"],
							Strings["Make Slope-Simple"],
							Strings["Make Slope-Solid"]
							]
			end
			def activate
				model=Sketchup.active_model
				sels=model.selection.grep(Sketchup::Face)
				(sels=sels[0].all_connected & sels) if sels && sels.length>0
				@edit_transform=model.axes.transformation
                @ip=Sketchup::InputPoint.new
				@ip1=Sketchup::InputPoint.new
				@ip2=Sketchup::InputPoint.new

                self.get_setting()
				@faces=[]
                @faces_hash={}

				faces=sels.select{|e| (e.valid? && e.is_a?(Sketchup::Face))} if sels
				#@get_parameter=false
				@change_direction=false
				edges=model.selection.to_a.select{|e| (e.valid? && e.is_a?(Sketchup::Edge))}
				if faces.length>=1
					faces=find_surface(faces)
					(@cancel=true; model.select_tool nil) if !set_parameter(faces,true)
					@state=0
					@height_slope = @height_raise[@mode]*(@faces.length+1)/@faces.length
					self.setstatus(model.active_view)
				else
					UI.messagebox(Strings["Select Faces"])
					@cancel=true
					model.select_tool nil
				end
			end
            def get_setting
                @setting = S4U::S4u_stair::instance_variable_get :@setting

				if @setting && (@setting.class==Hash)
                    @height_raise= @setting["@height_raise"]
                    @height_slab=@setting["@height_slab"]
                    @ratio_landing=@setting["@ratio_landing"]
                    @height_handrail=@setting["@height_handrail"]
                    @type_stair=@setting["@type_stair"]
                    @last_type_stair=@setting["@last_type_stair"]
                    @union_step=@setting["@union_step"]
                    @offset_handrail=@setting["@offset_handrail"]
                    @baluster=@setting["@baluster"]
                    @baluster_distance=@setting["@baluster_distance"]
                    @handrail=@setting["@handrail"]
				else
                    @height_raise=[15.cm,15.cm]
                    @height_slab=10.cm
                    @ratio_landing=2
                    @height_handrail=90.cm
                    @type_stair=0
                    @last_type_stair=[0,6]
                    @union_step=true
                    @offset_handrail=5.cm
                    @baluster=true
                    @baluster_distance=90.cm
                    @handrail=true
                    s=S4U::get_file(Dir_s4u_name,NAME)
                    if s && s[0]
                        @setting=JSON.parse s[0]
                        @height_raise= @setting["@height_raise"]
                        @height_raise=@height_raise.each_index{|i|
                                @height_raise[i]= parse_length(@height_raise[i]) }
                        @height_slab= parse_length(@setting["@height_slab"])
                        @ratio_landing= parse_length(@setting["@ratio_landing"])
                        @height_handrail= parse_length( @setting["@height_handrail"])
                        @type_stair=@setting["@type_stair"]
                        @last_type_stair=@setting["@last_type_stair"]
                        @union_step=@setting["@union_step"]
                        @offset_handrail= parse_length(@setting["@offset_handrail"])
                        @baluster=@setting["@baluster"]
                        @baluster_distance= parse_length(@setting["@baluster_distance"])
                        @handrail=@setting["@handrail"]
                    end
                end
                if @type_stair<6 && @mode!=0
                    @type_stair=@last_type_stair[@mode]
                elsif  @type_stair>=6 && @mode!=1
                    @type_stair=@last_type_stair[@mode]
                end
                rescue=>error
					p error,error.backtrace.join('\n')
            end
            def parse_length(input)
				(return 0) if !input
				input=input.to_s
				if !Sketchup.parse_length("1.1")
					input.gsub!(/\./, ',')
				else
					input.gsub!(/\,/, '.')
				end
				begin
					value=input.to_l
				rescue
					value=input.to_f
				end
				return value
			end
            def deactivate(view)
				if !@cancel
					@last_type_stair[@mode]=@type_stair

					make_stair
                    if  @height_raise && @height_slab && @ratio_landing && @height_handrail &&
                        @type_stair && @last_type_stair
                        @setting={}
                        @setting["@height_raise"] = @height_raise
                        @setting["@height_slab"] = @height_slab
                        @setting["@ratio_landing"] = @ratio_landing
                        @setting["@height_handrail"] = @height_handrail
                        @setting["@type_stair"] = @type_stair
                        @setting["@last_type_stair"] = @last_type_stair
                        @setting["@union_step"] = @union_step
                        @setting["@offset_handrail"] = @offset_handrail
                        @setting["@baluster"] = @baluster
                        @setting["@baluster_distance"] = @baluster_distance
                        @setting["@handrail"] = @handrail

                        S4U::S4u_stair::instance_variable_set(:@setting,@setting)
                        (puts "error save setting") if !S4U::set_file(Dir_s4u_name,NAME,[@setting.to_json])
                    end
				end
			end
			def onSetCursor
				UI.set_cursor(@cursor_id) if @cursor_id
			end
			def getExtents
				bb = Sketchup.active_model.bounds
				bb.add @ip.position if @ip && @ip.valid?
				return bb
			 end
			def set_parameter(faces,start=false)
				@faces.clear
				edges=faces.flat_map{|f| f.edges.select{|e| (e.faces & faces).length==1}}
				faces.each_index{|i|
					f=faces[i]
					pre_step = (i==0) ? nil : faces[i-1]
					next_step = (i==(faces.length-1)) ?  nil : faces[i+1]
					fd=S4U::S4u_stair::Face_Stair.new(f,i,pre_step,next_step)
					#fd.set_origin()
					if fd
						@faces<<fd
						@faces_hash[f]=fd
					end
				}
				if @faces.length>1
					length = edges.length
					(edges= edges - @faces[0].edges[0][1]) if @faces[0].edges[0] && @faces[0].edges[0][1]
					if @faces[-1].edges[2] && @faces[-1].edges[2][1]
						(edges= edges - @faces[-1].edges[2][1])
					elsif @faces[-1].edges[1] && @faces[-1].edges[1][1]
						(edges= edges - @faces[-1].edges[1][1])
					end
					if edges.length==length
						edges= edges - [@faces[-1].edges[1][1][-1],@faces[-1].edges[3][1][-1]]
					end
					edges=S4U::S4u_stair.find_vertices(edges)
					edges.each_index{|i|
						if !(@faces[0] &&  @faces[0].edges[0] && @faces[0].edges[0][0] &&
						@faces[0].edges[0][0].include?(edges[i][0][0]))
							edges[i]=[edges[i][0].reverse,edges[i][1].reverse]
						end
					}
					@border=edges
					face_min=@faces.min_by{|f| f.face.area}
					@faces.each{|f|
						if ((f.edges[0][0] & @border[0][0]) != [f.edges[0][0][0]]) &&
						((f.edges[0][-1] & @border[1][0]) != [f.edges[0][0][-1]])
							f.edges[0][0].reverse!
							f.edges[0][1].reverse!
						end
						if f.edges[2] && (!f.edges[2].empty?) && ((f.edges[2][0] & @border[0][0]) != [f.edges[2][0][0]]) &&
						((f.edges[2][-1] & @border[1][0]) != [f.edges[2][0][-1]])
							f.edges[2][0].reverse!
							f.edges[2][1].reverse!
						end
					}
					@faces.each{|f|
						if f.edges[1] && f.edges[1][0]
							if (f.edges[1][0] & @border[0][0]).length==0 &&
								(f.edges[1][0] & @border[1][0]).length>0
								ed=f.edges[1].clone
								f.edges[1]=f.edges[3]
								f.edges[3]=ed
							end
						else
							if f.edges[3] && f.edges[3][0]
								if (f.edges[3][0] & @border[0][0]).length==0 &&
									(f.edges[3][0] & @border[1][0]).length>0
									ed=f.edges[1].clone
									f.edges[3]=f.edges[1]
									f.edges[1]=ed
								end
							end
						end
						f.landing=f.index if f.face.area > (face_min.face.area*@ratio_landing)
					}
				else
					curves=edges.collect{|e| e.curve}.compact.uniq
					edges2=[]
					# if curves.length==1
						# list=S4U::S4u_stair.find_vertices(curves[0].edges.to_a)
						# edges2[0]=list[0]
						# list1=S4U::S4u_stair.find_vertices(edges-edges2[0][1],30.degrees)
						# if list1.length>=2
							# edges2[1]=list1[0]
							# edges2[3]=list1[1]
							# edges2[2]=(list-list1)[0]
							# if !edges2[1][0].include?(edges2[0][0][0])
								# edges2[1][0].reverse!
								# edges2[1][1].reverse!
							# end
							# if edges2[3] && !edges2[3][0].include?(edges2[0][0][-1])
								# edges2[3][0].reverse!
								# edges2[3][1].reverse!
							# end
							# if edges2[2] && !edges2[1][0].include?(edges2[2][0][0])
								# edges2[2][0].reverse!
								# edges2[2][1].reverse!
							# end
							# @faces[0].edges=edges2
							# edges3=[@faces[0].edges[1],@faces[0].edges[3]]
							# set_border(edges3)
							# @faces[0].set_origin_point(@faces[0].edges[0][0][0].position)
						# end
					# end
					if curves.length>=2 && (curves[0].vertices & curves[1].vertices).length==0
						list=S4U::S4u_stair.find_vertices(curves[0].edges.to_a)
						edges2[1]=list[0]
						list=S4U::S4u_stair.find_vertices(curves[1].edges.to_a)
						edges2[3]=list[0]
						list1=S4U::S4u_stair.find_vertices(edges-(edges2[1][1]+edges2[3][1]))
						if list1.length>=2
							edges2[0]=list1[0]
							edges2[2]=list1[1]
							#edges2[2]=(list-list1)[0]
							if !edges2[0][0].include?(edges2[1][0][0])
								edges2[1][0].reverse!
								edges2[1][1].reverse!
							end
							if edges2[3] && !edges2[0][0].include?(edges2[3][0][0])
								edges2[3][0].reverse!
								edges2[3][1].reverse!
							end
							if edges2[2] && !edges2[1][0].include?(edges2[2][0][0])
								edges2[2][0].reverse!
								edges2[2][1].reverse!
							end
							@faces[0].edges=edges2
							edges3=[@faces[0].edges[1],@faces[0].edges[3]]
							set_border(edges3)
							@faces[0].set_origin_point(@faces[0].edges[0][0][0].position)
						end
					else
						edges1=S4U::S4u_stair.find_vertices(edges,30.degrees)
						if edges1.length>=3
							edges2[0]=edges1[2]
							list=S4U::S4u_stair.find_vertices((edges-edges2[0][1]),30.degrees)
							list1=list.select{|l|( l[0] & edges2[0][0]).length>0}
							edges2[1]=list1[0]
							edges2[3]=list1[1]
							edges2[2]=(list-list1)[0]
							if !edges2[0][0].include?(edges2[1][0][0])
								edges2[1][0].reverse!
								edges2[1][1].reverse!
							end
							if edges2[3] && !edges2[0][0].include?(edges2[3][0][0])
								edges2[3][0].reverse!
								edges2[3][1].reverse!
							end
							if edges2[2] && !edges2[1][0].include?(edges2[2][0][0])
								edges2[2][0].reverse!
								edges2[2][1].reverse!
							end
							if edges2[0][1].length>edges2[1][1].length
								@faces[0].edges=[edges2[1],edges2[0],edges2[3],edges2[2]]
							else
								@faces[0].edges=edges2
							end
							edges3=[@faces[0].edges[1],@faces[0].edges[3]]
							set_border(edges3)
							@faces[0].set_origin_point(@faces[0].edges[0][0][0].position)
						else
							return nil
						end
					end
					if start
						if @faces.length==1 && @faces[0].edges[0] && @faces[0].edges[1] &&
						((@faces[0].edges[0][0].length )>(@faces[0].edges[1][0].length))
							@change_direction=!@change_direction
						end
					end
					change_direction if @change_direction
					return true
				end
			end
			def set_border(edges)
				@border=edges
				@faces.each{|f|
					if ((f.edges[0][0] & @border[0][0]) != [f.edges[0][0][0]]) &&
					((f.edges[0][-1] & @border[1][0]) != [f.edges[0][0][-1]])
						f.edges[0][0].reverse!
						f.edges[0][1].reverse!

					end
					if f.edges[2] && (!f.edges[2].empty?) && ((f.edges[2][0] & @border[0][0]) != [f.edges[2][0][0]]) &&
					((f.edges[2][-1] & @border[1][0]) != [f.edges[2][0][-1]])
						f.edges[2][0].reverse!
						f.edges[2][1].reverse!
					end
				}
				@faces.each{|f|
					if f.edges[1] && f.edges[1][0]
						if (f.edges[1][0] & @border[0][0]).length==0 &&
							(f.edges[1][0] & @border[1][0]).length>0
							ed=f.edges[1].clone
							f.edges[1]=f.edges[3]
							f.edges[3]=ed
						end
					else
						if f.edges[3] && f.edges[3][0]
						if (f.edges[3][0] & @border[0][0]).length==0 &&
							(f.edges[3][0] & @border[1][0]).length>0
							ed=f.edges[1].clone
							f.edges[3]=f.edges[1]
							f.edges[1]=ed
						end
					end
					end
				}
			end

			def make_stair()
				model=Sketchup.active_model
				entities=model.active_entities
				return if !@faces
				model.start_operation TOOL,true,false,false
					if @type_stair==7
						make_slopes
					else
						make_treads
					end
					make_handrails if @handrail || @baluster
				model.commit_operation
				rescue => detail
					p detail
					model.abort_operation
					p detail.backtrace.join("\n")
			end
			def make_treads()
				model=Sketchup.active_model
				entities=model.active_entities
				raises=[]
				height = (@type_stair>=6) ? @height_slope : @height_raise[@mode]
				@height_slab=10.cm if (@height_slab==0 && @type_stair<6)
				(0..@faces.length-1).each{|i|
					raises<<@faces[i].make_step(@type_stair,height,@height_slab)
				}
				raises<<@faces[-1].make_step(-1,@height_raise[@mode]) if @type_stair<4
				g1=entities.add_group raises.compact
				if @union_step
					if @type_stair!=0 #&& @type_stair
							grp=raises.shift
							raises.each{|g|
								if grp && grp.manifold? && g.manifold?
									grp=grp.outer_shell(g)
								elsif g.manifold?
									grp=g
								end
							}
							S4U::S4u_stair.clean_edge(grp.entities)
					end
					g1.entities.grep(Sketchup::Group).each{|e| e.explode}
					if @type_stair>=6
						S4U::S4u_stair.clean_edge(g1.entities)
					end
				end
				g1.name=Strings["Raise"] if g1
			end
			def get_plane_by_points(points)
				points=points.clone.compact
				if points.length>2 && points[0] && points[1] && points[2]
					v1=points[0]-points[1]
					v2=points[2]-points[1]
					vt=v2.cross v1
					if v1.length!=0 && v2.length!=0 && vt.length!=0
						ang=v1.angle_between v2
						t=Geom::Transformation.rotation points[1],vt,ang*0.5
						v=v2.transform t
						vz=vt.cross v
						return [points[1],vz] if vz.length!=0
					end
				elsif points.length==2 && points[0] && points[1] && points[0]!=points[1]
					vz=points[1]-points[0]
					return [points[0],vz]
				else
					return [points[0],Z_AXIS.clone]
				end
			end
			def find_next(i,j)
				((i+1)..@faces.length-1).each{|ii|
					return @faces[ii].edges[j] if @faces[ii].edges[j] && !@faces[ii].edges[j].empty? &&
					(@faces[ii].edges[j][0]-@faces[ii].edges[2][0]).length>0
				}
				return []
			end
			def find_pre(i,j)
				(i-1).downto(0).each{|ii|
					return @faces[ii].edges[j] if @faces[ii].edges[j] && !@faces[ii].edges[j].empty? &&
					(@faces[ii].edges[j][0]-@faces[ii].edges[2][0]).length>0
				}
				return []
			end
			def offset_handrail_plane(points,vec,vecz,border1=nil,border2=nil)
				points1=[]
				if vec && vec.length!=0 && points.length>1
						v=points[1]-points[0]
						v=vecz.cross v
						v.length=vec.length
						points1<< (points[0]+v)
						if points.length>2
							(1..points.length-2).each{|i|
								v=points[i]-points[i-1]
								v1=vecz.cross v
								v1.length=vec.length
								line1=[(points[i-1]+v1),((points[i]+v1)-(points[i-1]+v1))]
								v=points[i+1]-points[i]
								v1=vecz.cross v
								v1.length=vec.length
								line2=[(points[i]+v1),((points[i+1]+v1)-(points[i]+v1))]
								p=Geom::intersect_line_line(line1,line2)
								points1<<p if p
							}
						end
						v=points[-1]-points[-2]
						v=vecz.cross v
						v.length=vec.length
						points1<<(points[-1]+v)
				else
					points1=points
				end
				if border1 && border1[0] && border1[1] && points1.length>1
					p=Geom::intersect_line_plane([points1[0],points1[1].vector_to(points1[0])],border1)
					if p
						if ((p.distance(points1[0]) + p.distance(points1[1])) - ((points1[0]).distance(points1[1]))) <= 0.0001
							points1[0]=p
						else
							p[2]=points1[0][2]
							if p.distance(points1[0])<10.mm
								points1[0]== p
							else
								points1.unshift p
							end
						end
					end
				end
				if border2 && border2[0] && border2[1] && points1.length>1
					p=Geom::intersect_line_plane([points1[-2],(points1[-2].vector_to(points1[-1]))],border2)
					if p
						if (p.distance(points1[-2]) + p.distance(points1[-1])) -((points1[-2]).distance(points1[-1])) <=0.0001
							points1[-1]=p
						else
							p[2]=points1[-1][2]
							if p.distance(points1[-1])<10.mm
								points1[-1]== p
							else
								points1<< p
							end
						end
					end
				end
				return points1
			end
			def make_handrails
				handrails1=[]
				handrails2=[]
				hands1=[]
				hands2=[]
				planes=[]
				if @type_stair!=7
					(0..@faces.length-1).each{|i|
						height= (@type_stair>=6) ? @height_slope : @height_raise[@mode]
						#height=@height_handrail if height==0 && @mode==1
						hrs1=[]
						hrs2=[]
						step=@faces[i]
						hs=@faces[i].make_handrail(@type_stair,height,@height_handrail,@offset_handrail)
						p1=nil
						p2=nil
						[1,3].each{|j|
							if  step.edges[j] && step.edges[j][0]
								if i==0
									points=step.edges[j][0].collect{|p|p.position}
									p1=get_plane_by_points([points[0],points[1]])
									ps=find_next(i,j)
									if ps && ps[0]
										points_next=ps[0].collect{|p| p.position}
										p2=get_plane_by_points([points[-2],points[-1],points_next[1]])
									end
								elsif i==(@faces.length-1)
									points=step.edges[j][0].collect{|p| p.position}
									p2=get_plane_by_points([points[-1],points[-2]])
									ps=find_pre(i,j)
									if ps[0]
										points_pre=ps[0].collect{|p| p.position}
										p1=get_plane_by_points([points_pre[-2],points_pre[-1],points[1]])
									end
								else
									points=step.edges[j][0].collect{|p|p.position}
									ps=find_pre(i,j)
									if ps[0]
										points_pre=ps[0].collect{|p| p.position}
										p1=get_plane_by_points([points_pre[-2],points[0],points[1]])
									end
									ps=find_next(i,j)
									if ps[0]
										points_next=ps[0].collect{|p| p.position}
										p2=get_plane_by_points([points[-2],points_next[0],points_next[1]])
									end
								end
								if j==1
									hrs1=offset_handrail_plane(hs[0],nil,Z_AXIS.clone,p1,p2)
									#hrs1=hs[0]
								else
									hrs2=offset_handrail_plane(hs[1],nil,Z_AXIS.clone,p1,p2)
									#hrs2=hs[1]
								end
							end
						}
						handrails1<< hrs1
						handrails2<< hrs2
						hands1<< hrs1 if hrs1[0]
						hands2<< hrs2 if hrs2[0]
						if i==@faces.length-1
							hands1<< hrs1[-1] if hrs1[-1]
							hands2<< hrs2[-1] if hrs2[-1]
						end
					}
				else
					vec=Z_AXIS.clone
					h=@height_raise[@mode]*(@faces.length+1)
					vec.length=h

					v1= @border[1][0][0].position-@border[0][0][0].position
					v2= @border[0][0][1].position-@border[0][0][0].position
					z=v1.cross v2
					ps1= @border[0][0].collect{|p| p.position}
					ps2= @border[1][0].collect{|p| p.position}
					v=X_AXIS.clone
					v.length=@offset_handrail
					z= @offset_handrail>0 ? z.clone.reverse : z.clone
					ps1=S4U::S4u_stair.offset_points_border(ps1,v,z,nil,nil)
					hands1=S4U::S4u_stair.slope_points(ps1,vec,@height_handrail)

					v=X_AXIS.clone
					v.length=@offset_handrail
					z= @offset_handrail>0 ? z.clone.reverse : z.clone
					ps2=S4U::S4u_stair.offset_points_border(ps2,v,z,nil,nil)

					hands2=S4U::S4u_stair.slope_points(ps2,vec,@height_handrail)
					(0..hands1.length-2).each{|i| handrails1<<[hands1[i],hands1[i+1]]}
					(0..hands2.length-2).each{|i| handrails2<<[hands2[i],hands2[i+1]]}
				end

				model = Sketchup.active_model
				height= @type_stair>=6 ? @height_slope : @height_raise[@mode]
				heightstair=@height_raise[@mode]*(@faces.length)
				edges=[]
				hands1.flatten!;hands2.flatten!
				h1=S4U::S4u_stair::get_info_points(hands1)
				a=Math::asin(heightstair/h1[-1][1])
				ca=Math::cos(a)
				baluster_distance 	= ca!=0 ? @baluster_distance/Math::cos(a) : @baluster_distance
				h1=S4U::S4u_stair::get_points_equal(h1,baluster_distance)
				if baluster_distance*0.5 > (h1[-1][1]-h1[-2][1])
					h1.delete(h1[-2])
				end
				hands1=h1.collect{|h| h[0]}
				h1=S4U::S4u_stair::get_info_points(hands2)
				a=Math::asin(heightstair/h1[-1][1])
				ca=Math::cos(a)
				baluster_distance 	= ca!=0 ? @baluster_distance/Math::cos(a) : @baluster_distance
				h1=S4U::S4u_stair::get_points_equal(h1,baluster_distance)
				if baluster_distance*0.5 > (h1[-1][1]-h1[-2][1])
					h1.delete(h1[-2])
				end
				hands2=h1.collect{|h| h[0]}
				hands3= @baluster ?  (hands1+hands2) : [hands1[0],hands1[-1],hands2[0],hands2[-1]]
				height= @type_stair>=6 ? @height_slope : @height_raise[@mode]
				hands3.uniq!
				hands3.each{|p|
						v=Z_AXIS.reverse.clone
						ray = [p, v]
						p1=model.raytest(ray)
						if p1 && p && (p.distance(p1[0])<(@height_handrail+ height))
							edges<< [p,p1[0]]
						else
							#v.length = (@type_stair>=6 && @baluster)? @height_handrail :(@height_handrail+height)
							v.length=@height_handrail
							edges<< [p,(p+v)]
						end
				}
				g=Sketchup.active_model.active_entities.add_group
				edges.each{|e| g.entities.add_edges e}
				handrails1=edit_handrails(handrails1)
				handrails2=edit_handrails(handrails2)
				g.entities.add_curve handrails1.flatten if @handrail #&& handrails1.length>1
				g.entities.add_curve handrails2.flatten if @handrail #&& handrails2.length>1
				g.name=Strings["Handrail"]
				return g
			end
			def edit_handrails(handrails)
				(0..handrails.length-2).each{|i|
					line1=handrails[i][-2..-1]
					line2=handrails[i+1][0..1]
					if line1 && line2 && line1.length==2 && line2.length==2
						point=Geom::intersect_line_line line1,line2
						if point &&
							(point.distance(handrails[i][-2]) + point.distance(handrails[i][-1])) <= handrails[i][-1].distance(handrails[i][-2])
							handrails[i+1].unshift point
							handrails[i][-1]= point
						end
						if (handrails[i+1][0].distance(handrails[i][-1]))<=10.mm
							handrails[i+1][0]=handrails[i][-1]
						end
					end
				}
				return handrails
			end
			def make_slopes
				model=Sketchup.active_model
				entities=model.active_entities
				g=entities.add_group
				ps1= @border[0][0].collect{|p| p.position}
				vec=g.transformation.zaxis
				h=@height_raise[@mode]*(@faces.length+1)
				vec.length=h
				ps1=S4U::S4u_stair.slope_points(ps1,vec)
				ps2= @border[1][0].collect{|p| p.position}
				ps2=S4U::S4u_stair.slope_points(ps2,vec)
				S4U::S4u_stair.extrude_points_points(g,ps1,ps2,nil,nil,Z_AXIS)
				if @height_slab!=0
					points1=ps1
					points2=ps2
					trans=g.transformation
					vec=trans.zaxis.reverse
					vec.length=@height_slab
					g1=g.copy
					g1.transform! Geom::Transformation.new(vec)
					g1.entities.each{|e| e.reverse! if e && (e.is_a?Sketchup::Face)}
					if points1 && points2
						vec=trans.zaxis.reverse
						vec.length=@height_slab
						S4U::S4u_stair.extrude_points_points(g,[points1[0],points2[0]],[(points1[0]+vec),(points2[0]+vec)],@face)
						S4U::S4u_stair.extrude_points_points(g,[points1[-1],points2[-1]],[(points1[-1]+vec),(points2[-1]+vec)],@face)
						points11=S4U::S4u_stair.move_points(points1,vec)
						fs=S4U::S4u_stair.extrude_points_points(g,points1,points11[0],@face)
						points21=S4U::S4u_stair.move_points(points2,vec)
						fs=S4U::S4u_stair.extrude_points_points(g,points2,points21[0],@face)
					end
					g=entities.add_group(g1,g)
					g.entities.select{|e| e.explode if e.is_a?Sketchup::Group}
				end
				g.name=Strings["Slope"] if g
			end
			def make_slope_edges(edges)
				model=Sketchup.active_model
				entities=model.active_entities
				model.start_operation TOOL,true,false,false
				g=entities.add_group
				vec=g.transformation.zaxis
				list=S4U::S4u_stair.find_vertices(edges)
				if list.length==2
					ps1=list[0][0].collect{|p| p.position}
					ps2=list[1][0].collect{|p| p.position}
					ps2.reverse! if ps1[0].distance(ps2[0]) > ps1[0].distance(ps2[-1])
					h=@height_raise[@mode]*(@faces.length+1)
					vec.length=h
					ps1=S4U::S4u_stair.slope_points(ps1,vec)
					ps2=S4U::S4u_stair.slope_points(ps2,vec)
					S4U::S4u_stair.extrude_points_points(g,ps1,ps2,@face)
					g.name=Strings["Slope"] if g
				end
				model.commit_operation
				rescue => detail
					p detail
					model.abort_operation
					p detail.backtrace.join("\n")
			end
			def getMenu(menu)
				ms=[]
				@list_type.each_index{|i|
					ms<< menu.add_item(@list_type[i]){
						@type_stair=i
						setstatus(Sketchup.active_model.active_view)
					}
					menu.add_separator if i==5
				}
				ms.each_index{|i| menu.set_validation_proc(ms[i]){ @type_stair==i ? MF_CHECKED : MF_UNCHECKED  }}
				menu.add_separator
				m= menu.add_item(Strings["Reverse Direction"]){
					self.reverse_direction
					setstatus(Sketchup.active_model.active_view)
				}
				m= menu.add_item(Strings["Change Direction"]){
					@change_direction=!@change_direction
					self.change_direction
					setstatus(Sketchup.active_model.active_view)
				}
				m= menu.add_item(Strings["Set Parameter"]){
					self.get_parameter
					setstatus(Sketchup.active_model.active_view)
				}
			end
			def get_parameter
				#@get_parameter=true
				prompts = [Strings["Raise"],Strings["Slab"],Strings["Height Handrail"],Strings["Offset"],
							Strings["Landing/Tread"],Strings["Union Steps"],Strings["Handrail"],Strings["Baluster"],Strings["Baluster Distance"]]
				defaults = [@height_raise[@mode].to_l.to_s,@height_slab.to_l.to_s,@height_handrail.to_l.to_s,@offset_handrail.to_l.to_s,
							@ratio_landing.to_s,(@union_step ? "Yes":"No"),(@handrail ? "Yes":"No"),(@baluster ? "Yes":"No"),@baluster_distance.to_s]
				list=["","","","","","Yes|No","Yes|No","Yes|No",""]
				input = UI.inputbox(prompts, defaults,list,Strings["Set Parameter"])
				if input
					i=0
					t=input[i].to_l
					@height_raise[@mode]=t if (@mode==0 && t>0) || (@mode==1 && t>=0)
					@height_slope=@height_raise[@mode]*(@faces.length+1)/@faces.length
					t=input[i+=1].to_l
					@height_slab=t if (t>0 && @type_stair<6) || (t>=0 && @type_stair>=6)
					t=input[i+=1].to_l
					@height_handrail=t if t>0
					t=input[i+=1].to_l
					@offset_handrail=t if t
					t=input[i+=1].to_f
					@ratio_landing=t if t>=1
					t=input[i+=1]
					@union_step= t=="Yes"
					t=input[i+=1]
					@handrail= t=="Yes"
					t=input[i+=1]
					@baluster= t=="Yes"
					t=input[i+=1].to_l
					@baluster_distance=t if t>0
					faces=@faces.flat_map{|f| f.face}
					set_parameter(faces)
					setstatus(Sketchup.active_model.active_view)
				end
			end
			def reverse_direction
				if @faces.length>1
					faces=@faces.flat_map{|f| f.face}.reverse
					set_parameter(faces)
				else
					e=@faces[0].edges.collect{|e1| [e1[0].clone,e1[1].clone] if e1 }.compact
					@faces[0].edges[0]=e[2]
					@faces[0].edges[2]=e[0] if e[2]
					@faces[0].edges[1]=e[3][0].reverse,e[3][1].reverse if e[3]
					@faces[0].edges[3]=e[1][0].reverse,e[1][1].reverse if e[1]
					@border[0][0].reverse!
					@border[0][1].reverse!
					@border[1][0].reverse!
					@border[1][1].reverse!
					set_border(@border)
					@faces[0].set_origin_point(@faces[0].edges[0][0][0].position)
				end
			end
			def setstatus(view=nil)
				text = @list_type[@type_stair]
				text+= " | " +  Strings["Stair Height"] +  ": " +  (@height_raise[@mode]*(@faces.length+1)).to_l.to_s
				text+= " | " + 	Strings["Raise"] +  ": " + @height_raise[@mode].to_l.to_s
				text+= " | " + 	Strings["Slab"] +  ": " + @height_slab.to_l.to_s
				text+= " | " + 	Strings["Handrails"] +  ": " + @height_handrail.to_l.to_s
				#text+= " | " + 	Strings["Double click for set Index of Raise"]
				text+= " | " + 	Strings["Input Height Of Stair (ex: 4000), Raise(ex: 150s) or Slab(ex: 150e)"]
				Sketchup.status_text=text
				view.invalidate if view
			end
			def draw(view)
				@faces.each{|f|
					f.draw_origin(view)
					f.draw_grid view,@type_stair,((@type_stair<6)? @height_raise[@mode] : @height_slope)
				}
				if (@ctrl_press||@state==1) && @ip && @ip.valid?
					if @ip.display?
						@ip.draw(view)
					end
				end
				if( @ip2.valid? && @ip1.valid?)
					if @p_shift
						p=@p_shift
						p2_line=@ip.position.project_to_line([@ip1.position,p])
						view.draw_points p2_line, 9*@scale_factor, 2, "red"  if p2_line
						@ip2.copy! Sketchup::InputPoint.new(p2_line)
						view.line_stipple = "."
						view.drawing_color ="blue"
						view.draw_line(@ip.position, @ip2.position)
						view.line_stipple = ""
						view.drawing_color ="black"
					end
				end
				if @state==1 && @ip1 && @ip2 && @ip1.valid? && @ip2.valid?
					view.drawing_color="blue"
					view.line_width=4
					view.draw_line @ip1.position,@ip2.position
				end
			end
			def onMouseMove(flags, x, y, view)
				model=view.model
				@point=nil
				ip = view.inputpoint x,y
				# if @ip1.valid?
					# ip = view.inputpoint x,y,@ip1
				# end
				if ip && ip.valid? && ip.display?
					@ip.copy! ip
					if @state==0
						view.tooltip="     " + Strings["Select Point 1"]
						@ip_lock=nil
						setstatus(view)
					elsif @state==1
						view.tooltip="     " + Strings["Select Point 2"]
						if @shift_down_time && @p_shift && @ip!=@ip1
							p2_line=@ip.position.project_to_line([@ip1.position,@p_shift])
							@ip2.copy! (p2_line ? Sketchup::InputPoint.new(p2_line) : @ip)
						elsif @ip_lock
							p2_line=@ip.position.project_to_line([@ip1.position,@ip_lock])
							@ip2.copy! (p2_line ? Sketchup::InputPoint.new(p2_line) : @ip)
						else
							@ip2.copy! @ip
						end
						if @ip1.valid? && @ip2.valid?
							Sketchup.vcb_label=Strings["Length"]
							length = @ip1.position.distance(@ip2.position)
							Sketchup::set_status_text length.to_s, SB_VCB_VALUE
						end
						setstatus(view)
					end
				end
			end
			def onLButtonDown(flags, x, y, view)
					if @state==0 && @ctrl_press
						@ip1.copy! @ip
						@state=1
					elsif @state==1 #&& @ctrl_press
						#@ip2.copy! @ip
						if @ip1.valid? && @ip2.valid? && @ip1.position.distance(@ip2.position)>0
							height_raise=@ip1.position.distance(@ip2.position)/(@faces.length+1)
							@height_raise[@mode]=height_raise.to_l
							@height_slope=@height_raise[@mode]*(@faces.length+1)/@faces.length
							@state=0
							@ip1.clear;@ip2.clear
							view.lock_inference if view.inference_locked?
						end
					end
					setstatus(view)
			end
			def select_origin(x, y, view)
				if @state==0
					ph = view.pick_helper
					ph.init(x, y)
					ph.do_pick x,y
					index_ver=nil
					index_face=nil
					selectface=ph.picked_face
					face_stair=@faces_hash[selectface]
					if face_stair
						picked=nil;ve=nil;index_ver=nil
						ve=face_stair.vertices.find{|v|  ph.test_point(v.position,x,y,70) }
						if ve
							index_ver=face_stair.vertices.index(ve)
							face_stair.set_origin index_ver if index_ver
						end
						face_stair.draw_origin(view)
					end
				end
			end
			def find_surface(faces_in,face=nil)
				if !face
					faces=faces_in#.collect{|f| f.face}
					fa=faces.min_by{|f| f.edges.collect{|e| e.faces & faces_in}.compact.uniq.length}
					face=fa if fa
					face=faces_in[0] if !face
				end
				face_connected=(face.all_connected.grep(Sketchup::Face) & faces_in) & faces_in
				faces=[face]
				i=0
				face_connected.delete(face)
				length=face_connected.length
				while i< length && face_connected.length>0
					next_face=[]
					pre_face=faces[-1]
					[pre_face].each{|pre|
						next_face=[]
						face_connected.each{|f|
							(next_face<<f) if ((f.vertices & pre.vertices).length>1) && ((f.edges & pre.edges).length>0)
						}
						if next_face[0]
							faces << next_face[0]
							face_connected.delete next_face[0]
						end
					}
					i+=1
				end
				return faces
			end
			def onLButtonDoubleClick(flags, x, y, view)
				@state=0
				ph = view.pick_helper
				ph.do_pick x,y
				selectface=ph.picked_face
				if selectface
					face=@faces_hash[selectface]
					if face
						if @faces.length>1
							if @ctrl_press
								face.landing=!face.landing
							else
								prompts = [Strings["Index"],Strings["Landing?"]]
								defaults = [(face.index+1).to_s,(face.landing ? "Yes":"No")]
								list=["","Yes|No"]
								input = UI.inputbox(prompts, defaults,list,Strings["Set Raise Index"])
								if input
									index=input[0].to_i-1
									if index>=0 and index<@faces.length
										f1=@faces.find{|f| f.index==index}
										f1.index=face.index
										face.index=index
										face.landing= "Yes"==input[1]
									end
								end
							end
						else
							@change_direction=!@change_direction
							change_direction()
						end
						setstatus(view)
					else
						get_parameter
					end
				else
					get_parameter
				end
			end
			def change_direction
				e=@faces[0].edges.collect{|e1| [e1[0].clone,e1[1].clone] if e1}.compact
				@faces[0].edges[0]=e[1]
				@faces[0].edges[2]=e[3] if e[3]
				@faces[0].edges[1]=e[0]
				@faces[0].edges[3]=e[2] if e[2]
				@border[0]=[@faces[0].edges[1][0].clone,@faces[0].edges[1][1].clone]
				@border[1]=[@faces[0].edges[3][0].clone,@faces[0].edges[3][1].clone]
				set_border(@border)
				@faces[0].set_origin_point(@faces[0].edges[0][0][0].position)
			end
			def onReturn(view)
				#@cancel=true
				Sketchup.active_model.select_tool nil
			end
			def parse_length(input)
					(return 0) if !input
					input=input.to_s
					if !Sketchup.parse_length("1.1")
						input.gsub!(/\./, ',')
					else
						input.gsub!(/\,/, '.')
					end
					begin
						value=input.to_l
					rescue
						value=input.to_f
					end
					return value
				end
			def onUserText(text, view)
				#if @state==0
					if text.include?('s')
						input= parse_length(text.delete('s'))
						h=input.to_f
						@height_raise[@mode] = h if (@mode==0 && h>0) || (@mode==1 && h>=0)
						@height_slope=@height_raise[@mode]*(@faces.length+1)/@faces.length
					elsif text.include?('e')
						input= parse_length(text.delete('e'))
						@height_slab=input.to_f
					else
						h= parse_length(text)
						if (@mode==0 && h>0) || (@mode==1 && h>=0)
							@height_raise[@mode]=h.to_f/ (@faces.length+1)
							@height_slope=@height_raise[@mode]*(@faces.length+1)/@faces.length
						end
					end
					setstatus(view)
				#end
			end
			def resume(view)
				setstatus(view)
			end
			def onKeyUp(key, repeat, flags, view)
				if key==CONSTRAIN_MODIFIER_KEY
					@shift_down_time=nil
					@p_shift=nil
					view.lock_inference if view.inference_locked?
				elsif ((key == VK_CONTROL) || ( IS_OSX && (key==VK_ALT)))
					@ctrl_press=false
					setstatus(view)
				end
			end
			def onKeyDown(key, repeat, flags, view)
				if ((key == VK_CONTROL) || ( IS_OSX && (key==VK_ALT)))
					@ctrl_press=true
				end
				if key==9
					reverse_direction
				end
				if( key == CONSTRAIN_MODIFIER_KEY )
					@shift_down_time =true
					if( view.inference_locked? )
						view.lock_inference
					elsif( @state==1 && @ip.valid?)
					@p_shift=@ip.position
					end
				elsif key==VK_UP
					view.lock_inference if view.inference_locked?
					if @ip.valid? && @state>0
						v=@edit_transform.zaxis.clone
						v.length=1
						p1=@ip1.position + v
						ip1 = Sketchup::InputPoint.new(p1)
						view.lock_inference ip1,@ip
						@ip_lock=ip1.position
						@ip2.copy! ip1
					end
				elsif key==VK_LEFT
					view.lock_inference if view.inference_locked?
					if @ip.valid? && @state>0
						v=@edit_transform.yaxis.clone
						v.length=1
						p1=@ip1.position + v
						ip1 = Sketchup::InputPoint.new(p1)
						view.lock_inference ip1,@ip
						@ip_lock=ip1.position
						@ip2.copy! ip1
					end
				elsif key==VK_RIGHT
					view.lock_inference if view.inference_locked?
					if @ip.valid? && @state>0
						v=@edit_transform.xaxis.clone
						v.length=1
						p1=@ip1.position + v
						ip1 = Sketchup::InputPoint.new(p1)
						view.lock_inference ip1,@ip
						@ip_lock=ip1.position
						@ip2.copy! ip1
					end
				end
				setstatus(view)
			end
			def onCancel(reason, view)
				if @state==0
					@cancel=true
					Sketchup.active_model.select_tool nil
				elsif @state==1
					@state=0
				end
				view.lock_inference if view.inference_locked?
				setstatus(view)
			end
		end #end class
		class Face_Stair
			attr_accessor :xaxis,:yaxis,:zaxis,:origin,:vertices,:face,:origin_index,:rever,:index,:raise,:edges,:landing
			attr_reader :numver,:vx,:vy,:parallel,:transformation,:axis_points,:center,:pre_face,:next_face
			def initialize(face,index,pre_face=nil,next_face=nil)
				@face=face
				@index=index
				@pre_face=pre_face
				@next_face=next_face
				@edges=Array.new 4,[]
				@vertices=self.get_vertices
				@numver=@vertices.length
				@origin_index=0
				#@zaxis=@face.normal
				@zaxis=Sketchup.active_model.axes.zaxis
				@parallel=self.parallel?
				@center=self.center_face
				@rever=0
				@landing=nil
				setvar(true)
				#set_axis_points
				@height_raise=15.cm
				@height_slab=15.cm
			end
			def setvar(first=false)
				@origin=@vertices[0].position
				@xaxis=@origin.vector_to @vertices[1].position
				@yaxis=@zaxis.cross @xaxis
				@transformation=transformation
				if @pre_face && @next_face
					@edges[0]=split_edges(@face.edges & @pre_face.edges)[0]
					@edges[2]=split_edges(@face.edges & @next_face.edges)[0]
					edges=(@face.edges-@edges[2][1])- @edges[0][1]
					list=split_edges(edges)
					@edges[1]=list[0]
					@edges[3]=list[1]
					#@edges[3]=[@edges[2][0].reverse,@edges[2][1].reverse] if @edges[3]==nil
				elsif (!@pre_face) && @next_face
					@edges[2]=split_edges(@face.edges & @next_face.edges)[0]
					edges=@face.edges-@edges[2][1]
					if edges.length>2
						curves=edges.collect{|e| e.curve}.compact.uniq
						if curves.length==1 && (edges-curves[0].edges).length>1
							@edges[0]=split_edges(curves[0].edges)[0]
							list=split_edges((edges-@edges[0][1]))
							@edges[1]=list[0] ? list[0] : []
							@edges[3]=list[1] ? list[1] : []
						else
							list=split_edges(edges,true)
							ls=list.find_all{|l| l[0].any?{|v| @edges[2][0].include?(v)}}
							@edges[1]=ls[0]
							@edges[3]=ls[-1]
							list.delete(ls[0])
							list.delete(ls[-1])
							@edges[0]=list.transpose.collect{|l| l.flatten}
							if @edges[0].empty?
								@edges[0]=@edges[3]
								@edges[3]=[]
							end
							edges1=split_edges(@edges[0][1])
							@edges[0]=edges1[0] if edges1 && !edges1[0].empty?
						end
					else
						edges=split_edges(edges,true)
						@edges[0]=edges[0] if edges[0] && !edges[0].empty?
						@edges[1]=edges[1] if edges[1] && !edges[1].empty?
					end
				elsif @pre_face && (!@next_face)
					@edges[0]=split_edges(@face.edges & @pre_face.edges)[0]
					edges=@face.edges-@edges[0][1]
					if edges.length>2
						curves=edges.collect{|e| e.curve}.compact.uniq
						if curves.length==1 && (edges-curves[0].edges).length>1
							@edges[2]=split_edges(curves[0].edges)[0]
							list=split_edges((edges-@edges[2][1]))
							@edges[1]=list[0] ? list[0] : []
							@edges[3]=list[1] ? list[1] : []
						else
							list=split_edges(edges,true)
							ls=list.find_all{|l| l[0].any?{|v| @edges[0][0].include?(v)}}
							@edges[1]=ls[0]
							@edges[3]=ls[-1]
							list.delete(ls[0])
							list.delete(ls[-1])
							@edges[2]=list.transpose.collect{|l| l.flatten}
							if @edges[2].empty?
								@edges[2]=@edges[3]
								@edges[3]=[]
							end
							edges1=split_edges(@edges[2][1])
							@edges[2]=edges1[0] if edges1 && !edges1[0].empty?
						end
					else
						edges=split_edges(edges,true)
						@edges[2]=edges[0] if edges[0] && !edges[0].empty?
						@edges[1]=edges[1] if edges[1] && !edges[1].empty?
					end
				end
				if @edges[1] && @edges[1][0] && (@edges[0][0].include?(@edges[1][0][-1]) ||
					@edges[2][0].include?(@edges[1][0][0]))
					 @edges[1]=[@edges[1][0].reverse,@edges[1][1].reverse]
				end
				if @edges[3] && @edges[3][0] && (@edges[0][0].include?(@edges[3][0][-1])||
					@edges[2][0].include?(@edges[3][0][0]))
					@edges[3]=[@edges[3][0].reverse,@edges[3][1].reverse]
				end
			end
			def split_edges(edges,check_angle=false)
				list=S4U::S4u_stair.find_vertices edges,check_angle
				if list
					return list
				else
					return []
				end
			end
			def set_origin_point(point)
				p=point.project_to_plane @face.plane
				if p
					@origin=p
					@transformation=transformation
				end
				return p
			end
			def transformation
				return Geom::Transformation.new(@xaxis,@yaxis,@zaxis,@origin)
			end
			def transformation=(trans)
				@transformation=trans
				@xaxis,@yaxis,@zaxis,@origin=trans.xaxis,trans.yaxis,trans.zaxis,trans.origin
			end
			def axes_edit_transform
				model=Sketchup.active_model
				return model.axes.transformation if Sketchup.version.to_i>=16
				model.start_operation "get edit transform"
				ents=model.active_entities
				begin
					g=ents.add_group(ents.add_group)
					t=Geom::Transformation.new(g.transformation.xaxis,g.transformation.yaxis,g.transformation.zaxis,g.transformation.origin)
					g.erase! if g && g.valid? && !g.deleted?
				rescue
					t=model.edit_transform
				end
				model.abort_operation
				return t
			end
			def get_vertices
				ver=[]
				vertices=[]
				vertices =@face.outer_loop.vertices*3
				(0..@face.outer_loop.vertices.length-1).each { |i|
					j=@face.outer_loop.vertices.length+i
					p1=vertices[j-1].position.clone
					p2=vertices[j].position.clone
					p3=vertices[j+1].position.clone
					v1=p1.vector_to p2
					v2=p2.vector_to p3
					ver.push vertices[j] if not ( v1.parallel? v2)
				}
				return @face.outer_loop.vertices
				#return ver
			end
			def set_axis_points(view=Sketchup.active_model.active_view)
				# view=Sketchup.active_model.active_view
				size = view.pixels_to_model 30,@origin
				vecx=@xaxis.clone
				vecy=@yaxis.clone
				length=[@dx,@dy].min
				if vecx.length!=0 && vecy.length!=0
					vecx.length=size
					vecy.length=size
					(vecy.length = vecx.length = length) if length && (size > length)
					px=(@origin + vecx)
					py=(@origin + vecy)
					@vx=[@origin,px]
					@vy=[@origin,py]
					@axis_points=[px,py]
				end
			end
			def draw_origin(view,type_stair=0)
				view.line_width=4
				if @edges[0] && @edges[0][0]
					view.drawing_color= @index==0 ? "red" : "Orange"
					view.draw_polyline @edges[0][0].collect{|p| p.position}
				end
				view.line_width=3
				view.drawing_color= "Orange"
				view.draw_polyline @edges[2][0].collect{|p| p.position} if (!@next_face) && @edges[2] && @edges[2][0]
				view.drawing_color="Blue" #"blueviolet"
				view.line_width=4
				if @edges[1] && @edges[2] && @edges[1][0] && (@edges[1][0] - @edges[2][0]).length!=0
					view.draw_polyline @edges[1][0].collect{|p| p.position}
				end
				if @edges[3] && @edges[2] && @edges[3][0] && (@edges[3][0] - @edges[2][0]).length!=0
					view.draw_polyline @edges[3][0].collect{|p| p.position}
				end
				options = {
				  :font => "Arial",
				  :size => 15,
				  :bold => true,
				  :align => TextAlignRight
				}
				origin=@center
				cp=@face.classify_point(@center)
				if ![1,2,4,8].include?(cp) && @edges[0] && @edges[0][0]
					origin=@edges[0][0][0].position
				end
				view.draw_text view.screen_coords(origin),((@index+1).to_s + ( @landing ?  "L" : "")),options
			end
			def draw_grid(view,type_stair,height=15.cm)
				return if height==0
				view.line_width=2
				view.drawing_color="blue"
				step=height*(@index+1)
				normal=@zaxis
				normal.length=step
				if type_stair<6
					view.draw_polyline @edges[0][0].collect{|p| p.position+normal} if @edges[0] && @edges[0][0]
					view.draw_polyline @edges[2][0].collect{|p| p.position+normal} if @edges[2] && @edges[2][0]
				end
				if type_stair<6
					if @edges[1] && @edges[1][0] #&& (@edges[1][0] - @edges[2][0]).length!=0
						view.draw_polyline @edges[1][0].collect{|p| p.position+normal}
					end
					if @edges[3] && @edges[3][0]# && (@edges[3][0] - @edges[2][0]).length!=0
						view.draw_polyline @edges[3][0].collect{|p| p.position+normal}
					end
				else
					vec=@zaxis.clone
					vec.length=height
					normal=@zaxis
					normal.length=height*@index if @index!=0
					ps1=[];ps2=[]
					if @edges[1] && @edges[1][0] #&& (@edges[1][0] - @edges[2][0]).length!=0
						ps1=S4U::S4u_stair.slope_points(@edges[1][0].collect{|p| p.position},vec)
						if @index==0
							view.draw_polyline ps1.collect{|p| p}
						else
							view.draw_polyline ps1.collect{|p| p+normal}
						end
					end
					if @edges[3] && @edges[3][0]
						ps2=S4U::S4u_stair.slope_points(@edges[3][0].collect{|p| p.position},vec)
						if @index==0
							view.draw_polyline ps2.collect{|p| p}
						else
							view.draw_polyline ps2.collect{|p| p+normal}
						end
					end
					if !@next_face && !ps1.empty? && !ps2.empty?
						if @index>0
							view.draw_polyline (ps1[-1]+normal),(ps2[-1]+normal)
						else
							view.draw_polyline (ps1[-1]),(ps2[-1])
						end
					end
				end
			end
			def push(ps,points1)
				return if !points1 || !ps
				points=ps.clone
				if ((points[0].is_a?Geom::Point3d) && (points1[0].is_a?Geom::Point3d)) ||
					((points[0].is_a?Array) && (points1[0].is_a?Array))
					points1.each{|p|
						if !points.any?{|p1| (p1.x==p.x) && (p1.y==p.y) && (p1.z==p.z)}
							points<< p
						end
					}
					return points
				elsif (points[0].is_a?Sketchup::Vertex) && (points1[0].is_a?Sketchup::Vertex)
					points1.each{|p|
						if !points.any?{|p1| (p1.position.x==p.position.x) &&
						(p1.position.y==p.position.y) && (p1.position.z==p.position.z)}
							points<< p
						end
					}
					return points
				end
				return ps
			end
			def make_slope_solid(height_raise=@height_raise,height_slab=@height_slab)
				height=height_raise*(@index)
				@height_slab=height_slab
				entities=Sketchup.active_model.active_entities
				trans=get_transformation_step
				points1=nil
				points2=nil
				if @edges[1] && @edges[1][0]
					eds=@edges[1][0]
					vec=trans.zaxis
					vec.length=@height_raise
					points1=eds.collect{|p| p.position.transform trans.inverse}
					points11=S4U::S4u_stair.slope_points(points1,vec,height)
				else
					if @edges[2] && @edges[2][0]
						eds=@edges[2][0]
						vec=trans.zaxis
						vec.length=@height_raise
						points1=eds.collect{|p| p.position.transform trans.inverse}
						points11=S4U::S4u_stair.slope_points(points1,vec,height)
					end
				end
				if @edges[3] && @edges[3][0]
					eds=@edges[3][0]
					vec=trans.zaxis
					vec.length=@height_raise
					points2=eds.collect{|p| p.position.transform trans.inverse}
					points21=S4U::S4u_stair.slope_points(points2,vec,height)
				else
					if @edges[2] && @edges[2][0]
						eds=@edges[2][0].reverse
						vec=trans.zaxis
						vec.length=@height_raise
						points2=eds.collect{|p| p.position.transform trans.inverse}
						points21=S4U::S4u_stair.slope_points(points2,vec,height)
					end
				end
				if @edges[3] && @edges[3].empty? && @edges[0] && @index==0
					eds=@edges[0][0]
					vec=trans.zaxis
					vec.length=@height_raise
					points2=eds.collect{|p| p.position.transform trans.inverse}
					points21=S4U::S4u_stair.slope_points(points2,vec,height)
				end
				points11=[@edges[0][0][0].position.transform(trans.inverse) ]  if !(points1) || (points1.empty?)
				points21=[@edges[0][0][-1].position.transform(trans.inverse) ]  if !(points2) || (points2.empty?)
				g=entities.add_group
				g.transformation=trans
				vec=trans.zaxis
				if points11 && points21
					S4U::S4u_stair.extrude_points_points(g,points11,points21,nil,nil,Z_AXIS)
					S4U::S4u_stair.extrude_points_points(g,points1,points2,nil,nil,Z_AXIS.reverse)
				end
				if points1 && points11 && points2 && points21
					fs=S4U::S4u_stair.extrude_points_points(g,points1,points11,@face)
					fs=S4U::S4u_stair.extrude_points_points(g,points2,points21,@face)
				end
				vec=trans.zaxis.reverse
				vec.length=@height_slab
				S4U::S4u_stair.extrude_points_points(g,[points1[-1],points2[-1]],[(points11[-1]),(points21[-1])],@face)
				S4U::S4u_stair.extrude_points_points(g,[points1[0],points2[0]],[(points11[0]),(points21[0])],@face)
				return g if g
				return nil
			end
			def make_slope(height_raise=@height_raise,height_slab=@height_slab)
				@height_raise=height_raise
				@height_slab=height_slab
				entities=Sketchup.active_model.active_entities
				trans=get_transformation_step
				points1=nil
				points2=nil
				if @edges[1] && @edges[1][0]
					eds=@edges[1][0]
					vec=trans.zaxis
					vec.length=@height_raise
					points1=eds.collect{|p| p.position.transform trans.inverse}
					points1=S4U::S4u_stair.slope_points(points1,vec)
				else
					if @edges[2] && @edges[2][0]
						eds=@edges[2][0]
						vec=trans.zaxis
						vec.length=@height_raise
						points1=eds.collect{|p| p.position.transform trans.inverse}
						points1=S4U::S4u_stair.slope_points(points1,vec)
					end
				end
				if @edges[3] && @edges[3][0]
					eds=@edges[3][0]
					vec=trans.zaxis
					vec.length=@height_raise
					points2=eds.collect{|p| p.position.transform trans.inverse}
					points2=S4U::S4u_stair.slope_points(points2,vec)
				else
					if @edges[2] && @edges[2][0]
						eds=@edges[2][0].reverse
						vec=trans.zaxis
						vec.length=@height_raise
						points2=eds.collect{|p| p.position.transform trans.inverse}
						points2=S4U::S4u_stair.slope_points(points2,vec)
					end
				end
				if @edges[3] && @edges[3].empty? && @edges[0] && @index==0
					eds=@edges[0][0]
					vec=trans.zaxis
					vec.length=@height_raise
					points2=eds.collect{|p| p.position.transform trans.inverse}
					points2=S4U::S4u_stair.slope_points(points2,vec)
				end
				points1=[@edges[0][0][0].position.transform(trans.inverse) ]  if !(points1) || (points1.empty?)
				points2=[@edges[0][0][-1].position.transform(trans.inverse) ]  if !(points2) || (points2.empty?)
				g=entities.add_group
				g.transformation=trans
				vec=trans.zaxis
				if points1 && points2
					S4U::S4u_stair.extrude_points_points(g,points1,points2,nil,nil,Z_AXIS)
				end
				vec.length=@height_raise*@index
				g.transform! Geom::Transformation.new(vec)
				if @height_slab!=0
					vec=trans.zaxis.reverse
					vec.length=@height_slab
					g1=g.copy
					g1.transform! Geom::Transformation.new(vec)
					g1.entities.each{|e| e.reverse! if e && (e.is_a?Sketchup::Face)}
					if points1 && points2
						if !@pre_face
							vec=trans.zaxis.reverse
							vec.length=@height_slab
							S4U::S4u_stair.extrude_points_points(g,[points1[0],points2[0]],[(points1[0]+vec),(points2[0]+vec)],@face)
						end
						if !@next_face
							vec=trans.zaxis.reverse
							vec.length=@height_slab
							S4U::S4u_stair.extrude_points_points(g,[points1[-1],points2[-1]],[(points1[-1]+vec),(points2[-1]+vec)],@face)
						end
						points11=S4U::S4u_stair.move_points(points1,vec)
						fs=S4U::S4u_stair.extrude_points_points(g,points1,points11[0],@face)
						points21=S4U::S4u_stair.move_points(points2,vec)
						fs=S4U::S4u_stair.extrude_points_points(g,points2,points21[0],@face)
					end
					g=entities.add_group(g1,g)
					g.entities.select{|e| e.explode if e.is_a?Sketchup::Group}
				end
				return g if g
				return nil
			end
			def make_step(type,height_raise=@height_raise,height_slab=@height_slab)
				@height_raise=height_raise
				@height_slab=height_slab
				entities=Sketchup.active_model.active_entities
				if type==4
					t=get_transformation_step
					mesh = @face.mesh(7)
					g=entities.add_group
					g.transformation=t
					g.entities.add_faces_from_mesh mesh
					g.entities.transform_entities t.inverse,g.entities.to_a
					S4U::S4u_stair.clean_edge(g.entities,true)
					g.entities.select{|f| f && (f.is_a?Sketchup::Face)}.each{|fa| fa.pushpull(@height_raise*(@index+1))}
					return g
				elsif type==6
					return make_slope(@height_raise,@height_slab)
				elsif type==8
					return make_slope_solid(@height_raise,@height_slab)
				else
					g=entities.add_group
					g.transformation= get_transformation_step
					points=[];points1=[];points3=[]
					#if @landing #&& @index!=0
						set_origin_point(@edges[0][0][0].position)
						@xaxis=@edges[0][0][-1].position-@edges[0][0][0].position
						@yaxis=@zaxis.cross @xaxis
						v=center_face-@edges[0][0][0].position
						@yaxis.reverse! if v.angle_between(@yaxis)> Math::PI*0.5
						g.transformation=transformation
					#end
					if type==-1
						if !@next_face && @edges[2] && @edges[2][0]
							vec=g.transformation.zaxis
							vec.length=@height_raise
							points[2]=@edges[2][0].collect{|p| p.position.transform g.transformation.inverse}
							S4U::S4u_stair.extrude_points(g,points[2],vec,@height_raise,@face,-1)
							p =@edges[2][0]
						end
					else
						edges=@edges[0][1]#.uniq
						edges += (@edges[3][1]) if @edges[3] && !@edges[3].empty?
						edges += (@edges[2][1].reverse) if @edges[2] && !@edges[2].empty?
						edges += (@edges[1][1].reverse) if @edges[1] && !@edges[1].empty?
						list=split_edges(edges)
						if list[0][0]
							edges=list[0][0]
							f=g.entities.add_face(edges.collect{|p| p.position.transform g.transformation.inverse})
							f.reverse! if f
						end
						if height_slab>0
							if type==0
								vec=Z_AXIS.reverse.clone
								points[0]=@edges[0][0].collect{|p| p.position.transform g.transformation.inverse}
								vec.length=@height_raise
								S4U::S4u_stair.extrude_points(g,points[0],vec,@height_raise,@face)
							elsif type==1
								if @index==0
									f.pushpull -1*@height_raise
								elsif @landing
									f.pushpull -(@height_raise+@height_slab)
								else
									vec=Z_AXIS.reverse.clone
									points[0]=@edges[0][0].collect{|p| p.position.transform g.transformation.inverse}
									vec.length=points[0].length>2 ? @height_raise : (@height_raise+@height_slab)
									S4U::S4u_stair.extrude_points(g,points[0],vec,@height_raise,@face)
									if @edges[1] && @edges[1][0]
										eds=@edges[1][0]
										points[1]=eds.reverse.collect{|p| p.position.transform g.transformation.inverse}
										vec.length=@height_raise
										points1=S4U::S4u_stair.slope_points(points[1],vec,@height_slab)
										S4U::S4u_stair.extrude_points_points(g,points[1],points1,@face)
									 else
										eds=@edges[2][0]
										points[1]=eds.reverse.collect{|p| p.position.transform g.transformation.inverse}
										vec.length=@height_raise
										points1=S4U::S4u_stair.slope_points(points[1],vec,@height_slab)
										S4U::S4u_stair.extrude_points_points(g,points[1],points1,@face)
									end
									if @edges[3] && @edges[3][0]
										eds=@edges[3][0]
										points[3]=eds.reverse.collect{|p| p.position.transform g.transformation.inverse}
										vec.length=@height_raise
										points3=S4U::S4u_stair.slope_points(points[3],vec,@height_slab)
										S4U::S4u_stair.extrude_points_points(g,points[3],points3,@face)
									else
										eds=@edges[2][0].reverse
										points[3]=eds.reverse.collect{|p| p.position.transform g.transformation.inverse}
										vec.length=@height_raise
										points3=S4U::S4u_stair.slope_points(points[3],vec,@height_slab)
										S4U::S4u_stair.extrude_points_points(g,points[3],points3,@face)
									end
									if points1.length>0 && points3.length>0
										S4U::S4u_stair.extrude_points_points(g,points1,points3,nil,nil,Z_AXIS.reverse)

									end
								end
								g.entities.select{|e| e.find_faces if e && (e.is_a?Sketchup::Edge) && e.faces.length<=1}
							elsif type==2
								(f.pushpull -1*@height_slab) if f
								g1=entities.add_group
								g1.transformation=Geom::Transformation.new g.transformation.xaxis,g.transformation.yaxis,@zaxis,@edges[0][0][0].position
								#vec=g1.transformation.yaxis
								vec=Y_AXIS.clone
								points[0]=@edges[0][0].collect{|p| p.position.transform g1.transformation.inverse}
								vec.length=@height_slab
								v=Y_AXIS.clone
								#v=g1.transformation.yaxis
								v.length=@height_slab
								points_new=[]
								border1=[]
								border2=[]
								border1=@edges[1][0].collect{|p| p.position.transform g1.transformation.inverse} if @edges[1]
								border2=@edges[3][0].collect{|p| p.position.transform g1.transformation.inverse} if @edges[3]
								points_new=S4U::S4u_stair.offset_points(points[0],vec,Z_AXIS,border1,border2)
								ed= points[0] + points_new[2] + points_new[0].reverse + points_new[1].reverse
								ed=ed.uniq!{|e| [e.x,e.y,e.z]}
								if ed
									fa=g1.entities.add_face ed
								end
								if !fa
									S4U::S4u_stair.extrude_points_points(g1,points[0],points1)
								end
								g1.entities.select{|f| f.is_a?Sketchup::Face}.each{|f|
										f.reverse! if f.normal.angle_between(Z_AXIS) >0
									}
								S4U::S4u_stair.clean_edge(g1.entities)
								g1.entities.select{|f| f.is_a?Sketchup::Face}.each{|f|
										if @index==0
											f.pushpull(-(@height_raise))
										else
											f.pushpull(-(@height_raise+@height_slab))
										end
									}
							elsif type==3
								(f.pushpull @height_raise*(@index+1)) if f
							end
						end
					end
					S4U::S4u_stair.clean_edge(g.entities)
					if type!=3
						vec=g.transformation.zaxis
						vec.length=@height_raise*(@index+1)
						g.transform! Geom::Transformation.new(vec)
						if g1
							S4U::S4u_stair.clean_edge(g1.entities)
							g1.transform! Geom::Transformation.new(vec)
							g=g.outer_shell(g1) if g1.manifold? && g.manifold?
						end
					end
					return g if g
				end
				return nil
			end
			def get_transformation_step
				if @landing
					set_origin_point(@edges[0][0][0].position)
					@xaxis=@edges[0][0][-1].position-@edges[0][0][0].position
					@yaxis=@zaxis.cross @xaxis
					v=center_face-@edges[0][0][0].position
					@yaxis.reverse! if v.angle_between(@yaxis)> Math::PI*0.5
					return transformation
				else
					vx=@edges[0][0][-1].position-@edges[0][0][0].position
					vyt=nil
					#vyt=@edges[2][0][0].position-@edges[0][0][0].position if  @edges[2] && !@edges[2].empty?
					vyt=@edges[1][0][-1].position-@edges[0][0][0].position if @edges[1] && !@edges[1].empty?
					vyt=@edges[3][0][-1].position-@edges[0][0][0].position if @edges[3] && !@edges[3].empty?
					vy=@zaxis.cross vx
					vy.reverse! if vyt && (vyt.angle_between(vy)>Math::PI*0.5)
					return Geom::Transformation.new vx,vy,@zaxis,@edges[0][0][0].position
				end
				return transformation
			end
			def make_handrail(type,step,handrails=90.cm,offset_handrail=10.cm)
				@height_raise=step
				handrails-=step if type>=6
				points_handrails1=[]
				points_handrails2=[]
				trans=get_transformation_step
				border1=nil
				border2=nil
				if @edges[1] && @edges[1][0] #&& (@edges[1][0]-@edges[2][0]).length!=0
					points=@edges[1][0].collect{|p| p.position.transform trans.inverse}
					v=X_AXIS.clone
					v.length=offset_handrail
					points_new=[]
					# z=Z_AXIS.clone
					z= offset_handrail>0 ? Z_AXIS.reverse :  Z_AXIS.clone
					points_new=S4U::S4u_stair.offset_points_border(points,v,z,border1,border2)
					points=points_new
					vec=trans.zaxis
					vec.length=@height_raise
					if @landing && type<6
						vec.length=handrails
						points=points.collect{|p| p + vec}
					else
						points=S4U::S4u_stair.slope_points(points,vec,handrails)
					end
					points_handrails1+=points
				end
				if @edges[3] && @edges[3][0] #&& (@edges[3][0] - @edges[2][0]).length!=0
					points=@edges[3][0].collect{|p| p.position.transform trans.inverse}
					v=X_AXIS.clone.reverse
					v.length=offset_handrail
					points_new=[]
					# z=Z_AXIS.clone
					z= offset_handrail>0 ? Z_AXIS.clone : Z_AXIS.clone.reverse
					points_new=S4U::S4u_stair.offset_points_border(points,v,z,border1,border2)
					points=points_new
					vec=trans.zaxis
					vec.length=@height_raise
					if @landing  && type<6
						vec.length=handrails
						points=points.collect{|p| p + vec}
					else
						points=S4U::S4u_stair.slope_points(points,vec,handrails)
					end
					points_handrails2+=points
				end
				vec=trans.zaxis
				if @height_raise==0
					vec.length=handrails
				else
					vec.length=@height_raise*(@index+1)
				end
				points_handrails1=points_handrails1.collect{|p| (p+vec).transform trans}
				points_handrails2=points_handrails2.collect{|p| (p+vec).transform trans}
				return [points_handrails1,points_handrails2]
			end
			def next_origin
				@origin_index=@origin_index+1
				@origin_index=0 if @origin_index==@numver
				vers=@vertices*2
				@vertices.clear
				@vertices=vers[1..@numver]
				self.setvar
			end
			def previous_origin
				@origin_index=@origin_index-1
				(@origin_index=@numver-1)if @origin_index==-1
				vers=@vertices*2
				@vertices.clear
				@vertices=vers[@numver-1,@numver]
				self.setvar
			end
			def reverse_axis
				@rever=1-@rever
				@vertices=@vertices[1..(@numver-1)].reverse.unshift @vertices[0]
				setvar
			end
			def set_origin(index=nil)
				vers=@vertices*2
				if !index
					ver=@vertices.sort_by{|v| v.position.z && v.position.x}[0,2].sort_by{|v| v.position.y}[0]
					index=@vertices.index(ver)
				end
				length=@vertices.length+index-1
				@vertices.clear
				@vertices=vers[index..length]
				setvar
			end
			def parallel?
				if  @numver==4
					vers=@vertices
					v1=vers[0];v2=vers[1];v3=vers[2];vend=vers[3]
					vend_v3=vend.position.vector_to v3.position
					vx = v1.position.vector_to v2.position
					vy = v1.position.vector_to vend.position
					return true if (vend_v3.samedirection? vx and vend_v3.length==vx.length)
				end
				return false
			end
			def center_face
				cp=Geom::Point3d.new
				@vertices.each{|v|
					cp.x=cp.x+v.position.x
					cp.y=cp.y+v.position.y
					cp.z=cp.z+v.position.z
				}
				cp.x=cp.x/ @numver
				cp.y=cp.y/ @numver
				cp.z=cp.z/ @numver
				return cp
			end
		end #end class
		def self.main(mode=0)
			if mode==0 || mode==1
				Sketchup.active_model.select_tool S4U::S4u_stair::Stair.new(mode)
			end
		end
	end
end